<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class RegB004 extends Record {
    /**
     * @var array Lista de colunas esperadas para o bloco
     */   
    protected $templateColumns = [
        [
            "name" => "type_rule",
            "position" => "1",
            "size" => "4",
            "type" => RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            "name" => "address",
            "position" => "5",
            "size" => "45",
            "type" => RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            "name" => "street",
            "position" => "5",
            "size" => "30",
            "type" => RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            "name" => "number",
            "position" => "35",
            "size" => "5",
            "type" => RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            "name" => "complement",
            "position" => "40",
            "size" => "10",
            "type" => RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            "name" => "neighborhood",
            "position" => "50",
            "size" => "20",
            "type" => RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            "name" => "city",
            "position" => "70",
            "size" => "25",
            "type" => RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            "name" => "state",
            "position" => "95",
            "size" => "2",
            "type" => RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            "name" => "cep",
            "position" => "97",
            "size" => "8",
            "type" => RecordColumn::TYPE_NUMERIC,
        ],
        [
            "name" => "since",
            "position" => "105",
            "size" => "6",
            "type" => RecordColumn::TYPE_NUMERIC,
        ],
        [
            "name" => "filler_1",
            "position" => "111",
            "size" => "5",
            "type" => RecordColumn::TYPE_ALPHANUMERIC,
        ],
    ];    

    public function __construct($values = null) {
        $this->createColumns();
    }


}