<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks;

use Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\NXXX\SubTypeN210_00;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\NXXX\SubTypeN210_01;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\NXXX\SubTypeN210_99;
use Schaffen\SerasaRemessa\Utils\Record;

class RegN210 extends Record {
    protected $values;
    
    protected $blockCodeSubType;

    public $subtypeInstance;

    public function __construct($values = null, $blockCodeSubType = null) {
        // $this->values = $values;
        // $this->blockCodeSubType = $blockCodeSubType;

        switch ($blockCodeSubType) {
            case '00':
                $this->subtypeInstance = new SubTypeN210_00($values);
                break;
            case '01':
                $this->subtypeInstance = new SubTypeN210_01($values);
                break;
            case '99':
                $this->subtypeInstance = new SubTypeN210_99($values);
                break;
            default:
                $this->subtypeInstance = new SubTypeN210_00($values);
                break;
        }
    }

    public function getValues() {
        return $this->subtypeInstance->getValues();
    }

    public function setValues($values) {
        $this->subtypeInstance->setValues($values);
    }

    public function getSubTypeInstance() {
        return $this->subtypeInstance;
    }

}