<?php 

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\ClosingBlock;

use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\ConfN20000;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\MainBlock;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB376;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegF900;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegN001;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegN003;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegP002;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegP006;

use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB001;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB002;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB003;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB004;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB005;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB006;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB011;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB012;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB013;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB014;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB015;

use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB054;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB280;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB352;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB35P;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB353;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB354;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB356;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB357;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB358;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB359;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB360;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB361;

use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB362;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB363;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB364;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB365;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB366;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB367;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB368;

use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegA900;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegB900;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegN200;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegN210;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegN230;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegN240;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegN250;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegN270;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegN440;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegN700;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks\RegN705;

class Response {
    use Translator;    
    /**
     * @var array Lista de Blocos de consulta carregados
     */
    public $requestBlocks = [];

    /**
     * @var array Lista de Blocos de resposta carregados
     */
    public $responseBlocks = [];

    /**
     * @var array Lista de Blocos de consulta válidos
     */
    private $validReqBlocks = [
        'B49C' => MainBlock::class,
        'N001' => RegN001::class,
        'N003' => RegN003::class,
        'P002' => RegP002::class,
        'P006' => RegP006::class,
        'N20000' => ConfN20000::class,
    ];

    /**
     * @var array Lista de Blocos de resposta válidos
     */
    private $validResBlocks = [
        'B001' => RegB001::class,
        'B002' => RegB002::class,
        'B003' => RegB003::class,
        'B004' => RegB004::class,
        'B005' => RegB005::class,
        'B006' => RegB006::class,
        'B011' => RegB011::class,
        'B012' => RegB012::class,
        'B013' => RegB013::class,
        'B014' => RegB014::class,
        'B015' => RegB015::class,

        'B054' => RegB054::class,
        'B280' => RegB280::class,
        'B352' => RegB352::class,
        'B35P' => RegB35P::class,
        'B353' => RegB353::class,
        'B354' => RegB354::class,
        'B356' => RegB356::class,
        'B357' => RegB357::class,
        'B358' => RegB358::class,
        'B359' => RegB359::class,
        'B360' => RegB360::class,
        'B361' => RegB361::class,

        'B362' => RegB362::class,
        'B363' => RegB363::class,
        'B364' => RegB364::class,
        'B365' => RegB365::class,
        'B366' => RegB366::class,
        'B367' => RegB367::class,
        'B368' => RegB368::class,

        'B376' => RegB376::class,

        'F900' => RegF900::class,

        'A900' => RegA900::class,
        'B900' => RegB900::class,

        'N200' => RegN200::class,
        'N210' => RegN210::class,
        'N230' => RegN230::class,
        'N240' => RegN240::class,
        'N250' => RegN250::class,
        'N270' => RegN270::class,
        'N440' => RegN440::class,
        'N700' => RegN700::class,
        'N705' => RegN705::class,

        'T999' => ClosingBlock::class,

    ];

    /**
     * Carrega os dados da resposta da API e separa em blocos 
     * @param string $body String de resposta devolvido pela consulta à API do Serasa
     * @return Response Objeto de resposta da Api
     */
    public static function load($body) {
        $mainBlock = substr($body, 0, 400);
        // dd($mainBlock);
        // $i = 0;
        // $pos = 399;
        // $tam = 150;
        // while($i < 60) {
        //     $mainBlock .= ' ';
        //     $mainBlock .= substr($body, $pos, $tam);
        //     $i++;
        //     $pos+=$tam;
        // }
        // dd($mainBlock);
        $response = new self();
        $response->loadBlocks(array_merge([$mainBlock], str_split(substr($body, 400), 115)));
        return $response;
    }


    /**
     * Instância os blocos de acordo com a classe e seta os valores nas lista de consulta e requisição
     * @param array $blocks Blocos de consulta separados (400 caracteres para o primeiro e 115 para os demais)
     */
    private function loadBlocks($blocks) {
        // dd($blocks);
        foreach($blocks as $strBlock) {
            // print_r($strBlock);
            if(substr($strBlock, 0, 2) == "\n") {
                continue;
            }
            $blockCode = substr($strBlock, 0, 4);            
            if(isset($this->validReqBlocks[$blockCode])) {
                $block = new $this->validReqBlocks[$blockCode]();
                $block->load($strBlock);
                array_push($this->requestBlocks, $block);
            }
            
            $blockCode = substr($strBlock, 0, 4);
            $blockCodeSubType = substr($strBlock, 4, 2);
            if(isset($this->validResBlocks[$blockCode])) {
                if($blockCode == 'F900'){
                    $block_f900 = substr($strBlock, 4, 4);
                    if ($block_f900 == 'BPRD' || $block_f900 == 'AL05' || $block_f900 == 'BPDC' || $block_f900 == 'BPPG' || $block_f900 == 'BPTM' || $block_f900 == 'BPIR' || $block_f900 == 'RMF6' || $block_f900 == 'SPF3' || $block_f900 == 'CAFI' || $block_f900 == 'MSM3' || $block_f900 == 'P8JS' || $block_f900 == 'REHJ') {
                        $block = new $this->validResBlocks[$blockCode]();
                        $block->load($strBlock);
                    }
                } else {
                    $block = new $this->validResBlocks[$blockCode]($strBlock, $blockCodeSubType);
                    $block->getValues($strBlock);
                }
                array_push($this->responseBlocks, $block);
            }
        }
    }

    /**
     * @return array lista de blocos de consulta
     */
    public function getRequestBlocks() {
        return array_map(function($block) {
            return $block->getValues();
        }, $this->requestBlocks);
    }

    /**
     * @param \Illuminate\Support\Collection
     */
    public function getResponseBlocks() {
        return array_map(function($block) {
            return $block->getValues();
        }, $this->responseBlocks);

        // return collect(array_map(function($block) {
        //     return $block->getValues();
        // }, $this->responseBlocks));
    }
}