<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\F900;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class SubTypesQSCN_4 extends Record {
    public $name = "spc";

    public $templateColumns = [
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "cod_cons",
            'position' => 5,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "bloco",
            'position' => 9,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "docto",
            'position' => 11,
            'size' => 9,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "dig_docto",
            'position' => 20,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "rg",
            'position' => 22,
            'size' => 11,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "dt_nasc",
            'position' => 33,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "vinculo",
            'position' => 41,
            'size' => 1,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "ddd",
            'position' => 42,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "telefone",
            'position' => 46,
            'size' => 9,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "cidade",
            'position' => 55,
            'size' => 30,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "uf",
            'position' => 85,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "cep",
            'position' => 87,
            'size' => 9,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "filial",
            'position' => 96,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "situac",
            'position' => 100,
            'size' => 1,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "filler",
            'position' => 101,
            'size' => 15,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
    ];

    public function __construct($values = null) {
        $this->createColumns();
        
        if($values !== null) {
            $this->setValues($values);
        }
    }

    public function setValues($values) {
        $newValues = $this->getValues();
        
        $newValues['type_rule'] = substr($values, 0, 4);
        $newValues['cod_cons'] = substr($values, 4, 4);
        $newValues['bloco'] = substr($values, 8, 2);
        $newValues['docto'] = substr($values, 10, 9);
        $newValues['dig_docto'] = substr($values, 19, 2);
        $newValues['rg'] = substr($values, 21, 11);
        $newValues['dt_nasc'] = substr($values, 32, 8);
        $newValues['vinculo'] = substr($values, 40, 1);
        $newValues['ddd'] = substr($values, 41, 4);
        $newValues['telefone'] = substr($values, 45, 9);
        $newValues['cidade'] = substr($values, 54, 30);
        $newValues['uf'] = substr($values, 84, 2);
        $newValues['cep'] = substr($values, 86, 9);
        $newValues['filial'] = substr($values, 95, 4);
        $newValues['situac'] = substr($values, 99, 1);
        $newValues['filler'] = substr($values, 100, 15);
        
        $this->setColumnsValues($newValues);
    }
    
}