<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\F900;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class SubTypesREM1_6 extends Record {
    public $name = "spc";

    public $templateColumns = [
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "code_cons",
            'position' => 5,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "sub_tip",
            'position' => 9,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "telefone",
            'position' => 11,
            'size' => 13,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "sem1",
            'position' => 24,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "sem2",
            'position' => 32,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "sem3",
            'position' => 40,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "sem4",
            'position' => 48,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "sem5",
            'position' => 56,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "sem6",
            'position' => 64,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "sem7",
            'position' => 72,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
    ];

    public function __construct($values = null) {
        $this->createColumns();
        
        if($values !== null) {
            $this->setValues($values);
        }
    }

    public function setValues($values) {
        $newValues = $this->getValues();
        
        $newValues['type_rule'] = substr($values, 0, 4);
        $newValues['code_cons'] = substr($values, 4, 4);
        $newValues['sub_tip'] = substr($values, 8, 2);
        $newValues['telefone'] = substr($values, 10, 13);
        $newValues['sem1'] = substr($values, 23, 8);
        $newValues['sem2'] = substr($values, 31, 8);
        $newValues['sem3'] = substr($values, 39, 8);
        $newValues['sem4'] = substr($values, 47, 8);
        $newValues['sem5'] = substr($values, 55, 8);
        $newValues['sem6'] = substr($values, 63, 8);
        $newValues['sem7'] = substr($values, 71, 8);
        
        $this->setColumnsValues($newValues);
    }
}